=== debian/changelog ===
libdatachannel (0.19.4-0.1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 10 Dec 2023 12:56:54 -0800

libdatachannel-dmo (0.19.4-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 20 Nov 2023 13:05:57 +0100

libdatachannel-dmo (0.19.3-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 11 Nov 2023 01:25:20 +0100
