=== debian/rules ===
#!/usr/bin/make -f

# git clone https://github.com/paullouisageneau/libjuice/ deps/libjuice
# cd deps/libjuice
# git checkout 5f753ca
# cd ../..
# git clone https://github.com/SergiusTheBest/plog/ deps/plog
# cd deps/plog
# git checkout e21baec

# find -name '.git*' | xargs rm -rf 

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DUSE_SYSTEM_JSON=ON \
	-DUSE_SYSTEM_SRTP=ON \
	-DUSE_SYSTEM_USRSCTP=ON \
	-DUSE_SYSTEM_JUICE=OFF \
	-DUSE_SYSTEM_PLOG=OFF

override_dh_clean:
	dh_clean examples/streamer/samples/opus/sample-478.opus

override_dh_auto_test:

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym
