=== debian/watch ===
version=4

https://github.com/paullouisageneau/libdatachannel/tags \
(?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
